package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.DataEntry;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: SyntheticWriteData

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SyntheticWriteData")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SyntheticWriteData implements TransactionBody {
	public final TransactionType type = TransactionType.SYNTHETIC_WRITE_DATA;
	private TxID cause;
	private Url source;
	private Url initiator;
	private long feeRefund;
	private DataEntry entry;

    //
	public TxID getCause() {
	    return cause;
	}
	public void setCause(final TxID value) {
	    this.cause = value;
	}

	public SyntheticWriteData cause(final TxID value) {
	    setCause(value);
	    return this;
	}
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public SyntheticWriteData source(final Url value) {
	    setSource(value);
	    return this;
	}
	public SyntheticWriteData source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public Url getInitiator() {
	    return initiator;
	}
	public void setInitiator(final Url value) {
	    this.initiator = value;
	}

	public SyntheticWriteData initiator(final Url value) {
	    setInitiator(value);
	    return this;
	}
	public SyntheticWriteData initiator(final String value) {
	    setInitiator(Url.toAccURL(value));
	    return this;
	}
	public long getFeeRefund() {
	    return feeRefund;
	}
	public void setFeeRefund(final long value) {
	    this.feeRefund = value;
	}

	public SyntheticWriteData feeRefund(final long value) {
	    setFeeRefund(value);
	    return this;
	}
	public DataEntry getEntry() {
	    return entry;
	}
	public void setEntry(final DataEntry value) {
	    this.entry = value;
	}

	public SyntheticWriteData entry(final DataEntry value) {
	    setEntry(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.cause == null)) {
            marshaller.writeTxid(2, this.cause);
        }
        if (!(this.source == null)) {
            marshaller.writeUrl(3, this.source);
        }
        if (!(this.initiator == null)) {
            marshaller.writeUrl(4, this.initiator);
        }
        if (!(this.feeRefund == 0)) {
            marshaller.writeUint(5, this.feeRefund);
        }
        if (!(this.entry == null)) {
            marshaller.writeValue(6, entry);
        }
        return marshaller.array();
    }
}
